-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
--                                                                         --
--             MODULE Utilities.hs    -     December 2002                  --
--                                                                         --
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------

module Utilities where

--
--
--  Auxiliary functions
--
--

toFunc keyValuePairs key = case lookup key keyValuePairs of
                                Just value -> value

charToNum c = (ord c)-(ord '0')

strToNum = strToNum' . reverse
   where strToNum' [n] = charToNum n
         strToNum' (n:ns) = charToNum n +10*(strToNum' ns)

insertOrdered i [] = [i]
insertOrdered i (n:ns) | i<n = i:n:ns
                       | otherwise = n:insertOrdered i ns
                 
ordering [] = []
ordering [x] = [x]
ordering (x:xs) = if x<=y then x:ord else y:insertOrdered x ys
   where ord@(y:ys) = ordering xs



